#ifndef __COMMON_H
#define __COMMON_H

#define DIGIT_MAX 6

#define DISABLE 0
#define ENABLE  1

#define DUTY_CYCLE    32
#define DUTY_MAX      16
#define DUTY_MIN      2
#define DUTY_PWM_AMP1 18
#define DUTY_PWM_AMP2 34

#define TIME_MODE       0
#define DATE_MODE       1
#define YEAR_MODE       2
#define BRIGHTNESS      3
#define LIGHT_SENSOR_EN 4
#define LIGHT_SENSOR_TH 5
#define LIGHT_SENSOR_SW 6
#define GPS_EN          7
#define GPS_TZ          8

#define CONFIG_NONE            0
#define CONFIG_MIN             1
#define CONFIG_HOUR            2
#define CONFIG_DAY             3
#define CONFIG_DATE            4
#define CONFIG_MONTH           5
#define CONFIG_YEAR            6
#define CONFIG_CENTURY         7
#define CONFIG_BRIGHTNESS      8
#define CONFIG_LIGHT_SENSOR_EN 9
#define CONFIG_LIGHT_SENSOR_TH 10
#define CONFIG_LIGHT_SENSOR_SW 11
#define CONFIG_GPS_EN          12
#define CONFIG_GPS_TZ          13

#define MINUS       36
#define SUPRESS     37
#define FONT_OFFSET 55

#define TEMP_TURNON 20

#define COLON_PWM 0
#define COLON_SW  1
#define COLON_ON  2
#define COLON_OFF 3

#define SEG_HIGH PORTA
#define SEG_LOW  PORTC

#define PWM_MAX 253
#define PWM_LOW PWM_MIN
#define PWM_MIN 2

#define SW_LED_PORT         PORTE
#define SW_LED              PE3
#define GPS_SW_LED_PORT     PORTB
#define GPS_SW_LED          PB4
#define GPS_STATUS_LED_PORT PORTG
#define GPS_STATUS_LED      PG4

#define SW_2_PIN PIND
#define SW_2     PD4
#define SW_3_PIN PIND
#define SW_3     PD5
#define SW_4_PIN PIND
#define SW_4     PD6
#define SW_5_PIN PIND
#define SW_5     PD7

#define ENC_1_B_PORT  PING
#define ENC_1_B       PG0
#define ENC_1_SW_PORT PING
#define ENC_1_SW      PG1
#define ENC_2_B_PORT  PING
#define ENC_2_B       PG2
#define ENC_2_SW_PORT PING
#define ENC_2_SW      PG3

#define L_COLON_PWM OCR1A
#define R_COLON_PWM OCR1B
#define SEG_DOT_PWM OCR1C

#define GPS_PS_PORT PORTE
#define GPS_PS      PE2

void wait_ms(uint16_t t);
void set_segment(uint8_t msb, uint8_t lsb);
void set_dot(uint8_t pwm);

void on_sw_led(void);
void off_sw_led(void);
void toggle_sw_led(void);
void on_gps_sw_led(void);
void off_gps_sw_led(void);
void toggle_gps_sw_led(void);
void on_gps_status_led(void);
void off_gps_status_led(void);
void toggle_gps_9status_led(void);

uint8_t get_enc_1_B(void);
uint8_t get_enc_1_SW(void);
uint8_t get_enc_2_B(void);
uint8_t get_enc_2_SW(void);

void start_gps(void);
void stop_gps(void);
void toggle_gps(uint8_t val);

void max_brightness(void);
void normal_brightness(void);
void limit_brightness(void);
void set_brightness(uint8_t num, uint8_t val);
void set_source_brightness(uint8_t val);
void set_colon_brightness(uint8_t val);
void set_colon_source_brightness(uint8_t val);

void off_all_LED(void);

uint8_t get_day_char1(uint8_t val);
uint8_t get_day_char2(uint8_t val);

uint8_t get_max_date(void);

#endif
