#include <avr/io.h>
#include "port.h"

/* PORT
** IN :init input
** OUT:init output
** PU :init pullup
** PD :init pulldown 
**
** PA0 OUT PD SEG A1
** PA1 OUT PD SEG A2
** PA2 OUT PD SEG B
** PA3 OUT PD SEG C
** PA4 OUT PD SEG D1
** PA5 OUT PD SEG D2
** PA6 OUT PD SEG E
** PA7 OUT PD SEG F
**
** PB0 OUT PD DS3234S CS  (SPI_SS)
** PB1 OUT PD DS3234S SCK (SPI_SCK) & ISP
** PB2 OUT PD DS3234S DIN (SPI_MOSI)
** PB3 IN  PD DS3234S DOUT(SPI_MISO)
** PB4 OUT PD STATUS LED D15
** PB5 OUT PD L colon(PWM OC1A)
** PB6 OUT PD R colon(PWM OC1B)
** PB7 OUT PD SEG DP (PWM OC1C)
**
** PC0 OUT PD SEG G1
** PC1 OUT PD SEG G2
** PC2 OUT PD SEG H
** PC3 OUT PD SEG I
** PC4 OUT PD SEG J
** PC5 OUT PD SEG K
** PC6 OUT PD SEG L
** PC7 OUT PD SEG M
**
** PD0 IN PU SCL NC
** PD1 IN PU SCK NC
** PD2 IN PU RXD NC
** PD3 IN PU TXD NC
** PD4 IN PU SW2
** PD5 IN PU SW3
** PD6 IN PU SW4
** PD7 IN PU SW5
**
** PE0 PDI(ISP) & IN PD RXD (GPS TXD)
** PE1 PDO(ISP) & IN PD TXD (GPS RXD)
** PE2 OUT PD GPS SW(NJM2863F33)
** PE3 OUT PD STATUS LED D14
** PE4 IN  PU INT4(GPS 1pps)
** PE5 IN  PD INT5(ENC1 A)
** PE6 IN  PD INT6(ENC2 A)
** PE7 IN  PU INT7(DS3234S INT)
**
** PF0 OUT PD LED driver 1
** PF1 OUT PD LED driver 1
** PF2 OUT PD LED driver 1
** PF3 OUT PD LED driver 1
** PF4 OUT PD LED driver 1
** PF5 OUT PD LED driver 1
** PF6 IN  PD (ADC1)Light Sensor
** PF7 IN  PU NC
**
** PG0 IN  PD ENC1 B
** PG1 IN  PU ENC1 SW
** PG2 IN  PD ENC2 B
** PG3 IN  PU ENC2 SW
** PG4 OUT PD STATUS LED D16
*/

void init_port(void){
	DDRA  = 0b11111111;
	DDRB  = 0b11110111;
	DDRC  = 0b11111111;
	DDRD  = 0b00000000;
	DDRE  = 0b00001100;
	DDRF  = 0b00111111;
	DDRG  = 0b00010000;
	PORTA = 0b00000000;
	PORTB = 0b00000000;
	PORTC = 0b00000000;
	PORTD = 0b11111111;
	PORTE = 0b10010000;
	PORTF = 0b10000000;
	PORTG = 0b00001010;
}
